#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void kernel_cpu(int *A0,int *A1,float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,int N){
for(int i=0;i<N;i++){
A0[i] = A1[i]+A1[i];
B0[i] = B1[i]-B5[i]-B1[i]-B1[i];
}
}

int main(int argc,char **argv) {
int size=413478;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
int *A1;
A1 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
float *B5;
B5 = (float *)malloc(floatBytes);
for(int i=0;i<413478;i++){
A0[i] = 89+i+1;
A1[i] = 56*i+1;
B0[i] = 12.1565479351*i+1;
B1[i] = 30.1106991719*i+1;
B2[i] = 76.330743629+i+1;
B3[i] = 24.8395895454*i+1;
B4[i] = 58.1765318619+i+1;
B5[i] = 59.8102506226*i+1;
}
struct timeval time0,time1;
gettimeofday(&time0,NULL);
FILE *file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "1";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
kernel_cpu(A0,A1,B0,B1,B2,B3,B4,B5,413478);
file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "0";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F); 
free(A0);
free(A1);
free(B0);
free(B1);
free(B2);
free(B3);
free(B4);
free(B5);
printf("\n");return 0; }